pro stream,bow=bow,scale=fac,qm=qm,inc=inc,m1=m1,porb=porb,velscale=vfac,hic=hic,$
  loc=loc,eps=eps,cir=cir,read=re,stream=stream,kep=kep,bar=bar,ann=ann,$
  lobe=lobe,infile=infile,azm=azm,aztick=aztick,interp=interp,pscolor=pscolor,$
  pub=pub,over=over,nonax=nonax,xra=xra,yra=yra,ctab=ctab
; plot streams for different M1,q,i onto dopler map
print
; bow: black-on-white=1, white-on-black=0. Default: previous value used or else 1 
; scale: scale factor of plot size. Default: previous value used or else 1
; qm: mass ratio. Default: value in 'lobe.in'
; inc: inclination (degrees). Default: previous value used
; m1: M1. Default: previous value used
; porb: P_orb (days). Default: previous value used or value in 'ephem'
; vfac: velocity scale for vx and vy axis (default vfac=1: cm/s)
; hic:  high cut of intensity (%of image maximum). Default: previous value used or else 1
; loc:  low cut of intensity. Default: previous value used or else 0
; eps:  if not 0 make encapsulated postscript instead of printable ps. Default: previous value used or else 1
; cir:  plot circle of radius cir (cm/s) around center of mass. default: 0 (no circle)
; read: if set, force re-reading of data file lobe.out
; stream: if  not 0: plot stream.  Default: previous value used or else 1
; kep: if  not 0: plot kepler-velocity-at-stream-position. Default: previous value used or else 1
; bars: if not 0: plot connecting bars. Default: previous value used or else 1
; ann: if not 0: plot annotation. Default: previous value used or else 1 
; lobe: if  not 0: plot doppler ghost of M2-lobe. Default: previous value used or else 1 
; infile: name of dopmap file to be used. default: 'dop.out'
; azm: max azimuthal of stream to be plotted. Default and maximum: 270 degrees
; aztick: if not 0: plot azimuth ticks along stream. Default: previous value used or else 1
; interp: plotted map interpolated to reduce pixelation. Default: no interpolation
; pscolor: postcript output in color. Default: not in color.
; pub: postscript output for publication (no header, larger fonts, thicker lines).
; over: if 0, map only, without streams, marks etc. overrides other settings
; nonax: if not 0, subtract axisymmetric average from the map
; xra: if xra=0 or undefined, x-velocity range plotted is same as that of the whole map.
;   part of the map can be plotted by setting xra=[vmin,vmax], where vmin and vmax
;   your choice (in cm/s).
; yra: if yra=0 or undefined, y-velocity range plotted is same as that of the whole map.
;   part of the map can be plotted by setting yra=[vmin,vmax], where vmin and vmax
;   your choice (in cm/s).
; ctab: specify an IDL color table number. Default:15 (=Stern special). Use 
; XLOADCT to find out which tables IDL has.
common savestrpar, bows,facs,porbs,qms,incs,m1s,vfs,hics,locs,cirs,strs,keps,bars,$
  anns,lobs,epss,fidents,azms,azticks,infs,ints,pscs,pubs,overs,nonaxs,xras,yras,ctabs
common mapdata,nph,nvp,nv,w0,gamma,pha,vp,dm,ih,iw,pb0,pb1,ns,ac,al,clim,norm,wid,af,$
  va,im,dmr,dpx,abs,atm,cfi
common axim,imav,aset
if n_elements(bow) eq 0 then if n_elements(bows) eq 0 then bow=1 else bow=bows
close,/all
if bow gt 0 then bow=1
if bow lt 0 then bow=0
bows=bow
if n_elements(fac) eq 0 then if n_elements(facs) eq 0 then fac=1 else fac=facs
facs=fac
if n_elements(hic) eq 0 then if n_elements(hics) eq 0 then hic=1 else hic=hics
hics=hic
if n_elements(loc) eq 0 then if n_elements(locs) eq 0 then loc=0 else loc=locs
locs=loc
if n_elements(vfac) eq 0 then if n_elements(vfs) eq 0 then vfac=1 else vfac=vfs
vfs=vfac
if n_elements(cir) eq 0 then if n_elements(cirs) eq 0 then cir=0 else cir=cirs
cirs=cir
if n_elements(stream) eq 0 then if n_elements(strs) eq 0 then stream=1 else stream=strs
strs=stream
if n_elements(kep) eq 0 then if n_elements(keps) eq 0 then kep=1 else kep=keps
keps=kep
if n_elements(bar) eq 0 then if n_elements(bars) eq 0 then bar=1 else bar=bars
bars=bar
if n_elements(ann) eq 0 then if n_elements(anns) eq 0 then ann=1 else ann=anns
anns=ann
if n_elements(lobe) eq 0 then if n_elements(lobs) eq 0 then lobe=1 else lobe=lobs
lobs=lobe
if n_elements(eps) eq 0 then if n_elements(epss) eq 0 then eps=0 else eps=epss
epss=eps
if n_elements(azm) eq 0 then if n_elements(azms) eq 0 then azm=270. else azm=azms
azm=min([azm,265])
azms=azm
if n_elements(aztick) eq 0 then if n_elements(azticks) eq 0 then aztick=1 else aztick=azticks
azticks=aztick
if n_elements(infile) eq 0 then if n_elements(infs) eq 0 then infile='dop.out' else infile=infs
infs=infile
if n_elements(interp) eq 0 then if n_elements(ints) eq 0 then interp=0 else interp=ints
ints=interp
if n_elements(pscolor) eq 0 then if n_elements(pscs) eq 0 then pscolor=0 else pscolor=pscs
pscs=pscolor
if n_elements(pub) eq 0 then if n_elements(pubs) eq 0 then pub=0 else pub=pubs
pubs=pub
if n_elements(over) eq 0 then if n_elements(overs) eq 0 then over=1 else over=overs
overs=over
if n_elements(nonax) eq 0 then if n_elements(nonaxs) eq 0 then nonax=0 else nonax=nonaxs
nonaxs=nonax
if n_elements(xra) eq 0 then if n_elements(xras) eq 0 then xra=0 else xra=xras
xras=xra
if n_elements(yra) eq 0 then if n_elements(yras) eq 0 then yra=0 else yra=yras
yras=yra
if n_elements(ctab) eq 0 then if n_elements(ctabs) eq 0 then ctab=15 else ctab=ctabs
ctabs=ctab

if over eq 0 then begin
  cir=0
  stream=0
  kep=0
  bars=0
  ann=0
  lobe=0
  aztick=0
endif

ntab=ctabs                         ; color table number 
get_lun,lun
if kep ne 0 or stream ne 0 or lobe ne 0 then strop=1 else strop=0 ; overplot needed
if over eq 0 then strop=0       ; override if no-overplot specified
if strop eq 1 then begin
; determine q
  ex=findfile('lobe.in')         ; see if lobe.in exists and read q value
  if ex(0) ne '' then begin
    openr,lun,'lobe.in'
    qml=0.
    readf,lun,qml  
    close,lun
  endif 
  if n_elements(qm) eq 0 then $	; if not set in keyword
    if n_elements(qms) ne 0 then $	; if not in memory
      qm=qms else begin		; prompt
      print,'qm?'
      read,qm
    endelse
  qms=qm
  old = 0
  if n_elements(qml) ne 0 then if qml eq qm then old=1
  if ex(0) eq '' or old eq 0 then begin  ; new lobe.in needed
    openw,lun,'lobe.in'
    printf,lun,qm
    close,lun
  endif
  spawn,'make lobe.out',dump      ; recompile and/or rerun lobe if needed  

  if n_elements(inc) eq 0 and over eq 1 then begin   
    if n_elements(incs) eq 0 then  begin  ; prompt for value
      print,'inclination (degrees)?'
      read,inc
      incs=inc
    endif else inc=incs                  ; take value from common block
  endif
  incs=inc
  if n_elements(m1) eq 0 and over eq 1 then begin   
    if n_elements(m1s) eq 0 then begin   ; prompt for value
      print,'m1?'
      read,m1
      m1s=m1
    endif else m1=m1s                    ; take value from common block
  endif
  m1s=m1
; get orbital period. if not in keyword then in common, if not there in ephem or prompt
  if n_elements(porb) eq 0 and over eq 1 then begin   ; not defined in call
    if n_elements(porbs) ne 0 then porb=porbs else begin   ; no value yet in common blk
      ex=findfile('ephem')
      ex=ex(0)
      if ex ne '' then begin            ; read value from file ephem
        openr,lun,ex
        readf,lun,dum
        readf,lun,porb
        close,lun
        porbs=porb
      endif else begin                  ; prompt value, stop if <=0
        print,'p_orb (days)?'
        read,porb
        if porb le 0 then stop
      endelse
    endelse
  endif 
  porbs=porb
endif

set_plot,'ps'
device,/close_file  ; flush ps file before plotting
off=0.
del=0.06*fac
if pub eq 0 then begin 
  device,/landscape,font_size=12,bits_per_pixel=8,xsize=15,ysize=15
endif else begin
  device,/portrait,font_size=12,bits_per_pixel=8,xsize=15,ysize=15
endelse
device,filename='stream.ps'
if keyword_set(eps) then device,/encap else device,encap=0
xsiz=0.5*fac
ysiz=fac
vsiz=0.9*fac

; peek at infile to see if it's new
openr,lun,infile
readf,lun, dum,dum,dum,dum,fident
close,lun
oldid=0
if n_elements(fidents) ne 0 then if fidents eq fident then oldid=1 
if oldid eq 0 or n_elements(re) eq 1 then reamap,infile
fidents=fident

; subtract axsymm average (around cm!) from image, if needed 
if keyword_set(nonax) and n_elements(aset) eq 0 then begin
  imav=axfilt()
  aset=1
endif
if nonax eq 0 then imavs=0 else imavs=imav

; make velocity coordinates of edges of cells, for  the full map
vxy=(2*findgen(nv)/(nv-1)-1)*va
dv=vxy(1)-vxy(0)
vxy=[vxy(0)-dv/2,vxy(nv-1)+dv/2]
vx=vxy
vy=vxy

; set variables for velocity ranges set by call parameter
if n_elements(xras) eq 2 then begin
  vx=[max([xras(0),vx(0)]),min([xras(1),vx(1)])]
endif
if n_elements(yras) eq 2 then begin
  vy=[max([yras(0),vy(0)]),min([yras(1),vy(1)])]
endif
xle=vx(1)-vx(0)
yle=vy(1)-vy(0)
xfac=1.
yfac=1.
if xle ne yle then begin
  if xle gt yle then  yfac=yle/xle
  if yle gt xle then  xfac=xle/yle
endif
; pixel ranges to be included
nx=[0,nv-1]
ny=nx
if n_elements(xras) eq 2 then begin
  xx=(xras(0)-vxy(0))/dv
  if xx lt 0. then nx(0)=0 else nx(0)=fix(xx)+1
  xx=(xras(1)-vxy(0))/dv
  if xras(1) ge vxy(1) then nx(1)=nv-1 else nx(1)=fix(xx)-1
endif
if n_elements(yras) eq 2 then begin
  xx=(yras(0)-vxy(0))/dv
  if xx lt 0. then ny(0)=0 else ny(0)=fix(xx)+1
  xx=(yras(1)-vxy(0))/dv
  if yras(1) ge vxy(1) then ny(1)=nv-1 else ny(1)=fix(xx)-1
endif
imc=im(nx(0):nx(1),ny(0):ny(1))	; cut out image rectangle
nvx=nx(1)-nx(0)+1			; # of x-pixels
nvy=ny(1)-ny(0)+1

; scale image intensities according hi/lo cuts set
am=max(im-imavs)
im1=(imc-imavs)/am>0
im1=((im1-loc)/(hic-loc)>0)<1
if bow eq 1 then im1=1-im1
nxp=fix(0.9/(vsiz+del))
pos0=[0,off+del,vsiz*xfac,off+del+vsiz*yfac]
xt0='!5v!Dx!N '
yt0='!5v!Dy!N '
if vfac ne 1 then xt0=xt0+string(format='(''('',e7.0,'')'')',vfac)
if vfac ne 1 then yt0=yt0+string(format='(''('',e7.0,'')'')',vfac)

set_plot,'ps'		; plot to ps device
if pub eq 1 then begin	; thicker lines etc
  pxt=!x.thick
  pyt=!y.thick
  pth=!p.thick
  pch=!p.charsize
  pct=!p.charthick
  !x.thick=3
  !y.thick=3
  !p.thick=3
  !p.charsize=1.2
  !p.charthick=3
endif
if pscolor eq 1 then begin
  device,/color
  loadct,ntab,/silent
endif else device,color=0
 
mcol=!d.table_size-1 ; max no of colors of display
vxf=vx/vfac
vyf=vy/vfac
plot,vxf,vyf,position=pos0,xsty=5,ysty=5,/nodata,/noerase	; define plot area
yl=!y.window(1)-!y.window(0)
xl=!x.window(1)-!x.window(0)
if interp eq 1 then  begin	; plot at higher (interpolated) resolution
  nres=500
  nre=fix(nres/nv)		; factor for rebin
  im1=rebin(im1,nre*nvx,nre*nvy)   
endif

; parameter string for top of ps page
lab=string(format='(''!5ih='',i1,'' iw='',i1,'' pb0,1:'',2f6.3)',ih,iw,pb0,pb1)
lab=lab+string(format='('' ns='',i3,'' !7a!5='',f8.5,'' norm='',i1)',ns,al,norm)
if abs then lab=lab+'  ABSORPTION  '
lab=lab+string(format='('' nph,nvp,nv:'',3i4)',nph,nvp,nv)
lab=lab+string(format='('' !7k!5!D0!N='',f9.2,'' !7c!5='',e10.2)',w0,gamma)
lab=lab+string(format='('' wid='',e9.1,'' af='',f7.2)',wid,af)+'   '+cfi
if pub eq 0 then xyouts,0,1.1*!d.y_size,lab,charsize=0.7,/device	; plot label string

; velocity boundaries of pixel cut-out
vxr0=vxy(0)+nx(0)*dv
vxr1=vxy(0)+(nx(1)+1)*dv
vyr0=vxy(0)+ny(0)*dv
vyr1=vxy(0)+(ny(1)+1)*dv
xlr=xl*(vxr1-vxr0)/xle
ylr=yl*(vyr1-vyr0)/yle
x00=!x.window(0)+xl*(vxr0-vx(0))/xle
y00=!y.window(0)+yl*(vyr0-vy(0))/yle   
tv,im1*mcol,x00,y00,xsize=xlr,ysize=ylr,/norm			;pixel image
plot,vxf,vyf,position=pos0,xsty=1,ysty=1,$			;overplot axes
  xtit=xt0,ytit=yt0,/noerase,/nodat
stri=''
if strop then stroplot,stri,vy1 else vy1=0
if over eq 1 then xyouts,vxf(0),vyf(1)*1.05,stri
if nonax eq 1 then xyouts,0,vyf(1)*1.05,'nonaxisymmetric part', chars=1
fi=2*!pi*findgen(101)/100.
vam=cir/vfac
if cir ne 0 then oplot,vam*cos(fi),vam*sin(fi)-vy1,col=mcol*(1-bow)
device,/close_file
!x.range=0
!y.range=0
if pub eq 1 then begin
  !x.thick=pxt
  !x.thick=pyt
  !p.thick=pth
  !p.charsize=pch
  !p.charthick=pct
endif

set_plot,'x'
nm1=500*fac
if !d.window eq 3 then wshow,3 else window,3,xsiz=nm1,ysiz=nm1
loadct,ntab,/silent
erase
mcol=!d.table_size-1 ; max no of colors of display
vxt=vx(0)+[0,vx(1)-vx(0)]/xfac
vyt=vy(0)+[0,vy(1)-vy(0)]/yfac
plot,vxt/vfac,vyt/vfac,xsty=5,ysty=5,/nodata
px=!x.window*!d.x_vsize
py=!y.window*!d.y_vsize
sx=px(1)-px(0)
sy=py(1)-py(0)
sxr=sx*(vxr1-vxr0)/xle*xfac
syr=sy*(vyr1-vyr0)/yle*yfac
x00=px(0)+sx*(vxr0-vx(0))/xle
y00=py(0)+sy*(vyr0-vy(0))/yle   
if interp eq 1 then $
  tv,congrid(im1*mcol,sxr,syr,/inter),x00,y00 else $
  tv,congrid(im1*mcol,sxr,syr),x00,y00
plot,vxt/vfac,vyt/vfac,xsty=1,ysty=1,/noerase,/nodata,xtit='v!Dx!N',ytit='v!Dy!N'
if strop then stroplot,stri,vy1
xyouts,vx(0),vy(1)*1.05,stri
if cir ne 0 then oplot,vam*cos(fi),vam*sin(fi)-vy1,col=mcol*(1-bow)
free_lun,lun
return
end


